# coding: utf-8

"""
    VMware Aria Automation Assembler / CMX Service API

    When using Kubernetes integration, deploy and manage Kubernetes clusters and namespaces. The APIs that list collections of resources also support OData like implementation. Below query params can be used across CMX entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/cmx/api/resources/tags?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/cmx/api/resources/tags?$expand=true&$top=10&$skip=2```  3. `page` and `$size` - page used in conjunction with `$size` helps in pagination of resources.      ```/cmx/api/resources/tags?$expand=true&page=0&$size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /cmx/api/resources/tags?$filter=startswith(name, 'K8S')   # noqa: E501

    OpenAPI spec version: 2019-09-12
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class NodeSpec(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'external_id': 'str',
        'pod_cidr': 'str',
        'provider_id': 'str',
        'unschedulable': 'bool'
    }

    attribute_map = {
        'external_id': 'externalId',
        'pod_cidr': 'podCIDR',
        'provider_id': 'providerId',
        'unschedulable': 'unschedulable'
    }

    def __init__(self, external_id=None, pod_cidr=None, provider_id=None, unschedulable=None):  # noqa: E501
        """NodeSpec - a model defined in Swagger"""  # noqa: E501
        self._external_id = None
        self._pod_cidr = None
        self._provider_id = None
        self._unschedulable = None
        self.discriminator = None
        if external_id is not None:
            self.external_id = external_id
        if pod_cidr is not None:
            self.pod_cidr = pod_cidr
        if provider_id is not None:
            self.provider_id = provider_id
        if unschedulable is not None:
            self.unschedulable = unschedulable

    @property
    def external_id(self):
        """Gets the external_id of this NodeSpec.  # noqa: E501


        :return: The external_id of this NodeSpec.  # noqa: E501
        :rtype: str
        """
        return self._external_id

    @external_id.setter
    def external_id(self, external_id):
        """Sets the external_id of this NodeSpec.


        :param external_id: The external_id of this NodeSpec.  # noqa: E501
        :type: str
        """

        self._external_id = external_id

    @property
    def pod_cidr(self):
        """Gets the pod_cidr of this NodeSpec.  # noqa: E501


        :return: The pod_cidr of this NodeSpec.  # noqa: E501
        :rtype: str
        """
        return self._pod_cidr

    @pod_cidr.setter
    def pod_cidr(self, pod_cidr):
        """Sets the pod_cidr of this NodeSpec.


        :param pod_cidr: The pod_cidr of this NodeSpec.  # noqa: E501
        :type: str
        """

        self._pod_cidr = pod_cidr

    @property
    def provider_id(self):
        """Gets the provider_id of this NodeSpec.  # noqa: E501


        :return: The provider_id of this NodeSpec.  # noqa: E501
        :rtype: str
        """
        return self._provider_id

    @provider_id.setter
    def provider_id(self, provider_id):
        """Sets the provider_id of this NodeSpec.


        :param provider_id: The provider_id of this NodeSpec.  # noqa: E501
        :type: str
        """

        self._provider_id = provider_id

    @property
    def unschedulable(self):
        """Gets the unschedulable of this NodeSpec.  # noqa: E501


        :return: The unschedulable of this NodeSpec.  # noqa: E501
        :rtype: bool
        """
        return self._unschedulable

    @unschedulable.setter
    def unschedulable(self, unschedulable):
        """Sets the unschedulable of this NodeSpec.


        :param unschedulable: The unschedulable of this NodeSpec.  # noqa: E501
        :type: bool
        """

        self._unschedulable = unschedulable

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(NodeSpec, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NodeSpec):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
